comment $
//-----------------------------------------------------------------------------------//
//  Source code                                                                      //
//                                                                                   //
//  Written      by  Chib, amdtm                     http://www.xxcontrols.com       //
//                                                                                   //
//  FileName   : XXControls.asm                                                      //
//  Description: libraries of functions for work with menu                           //
//  Version    : 1.00.000, January 1, 2004                                           //
//-----------------------------------------------------------------------------------//
$ 
 
    .486
    .model flat, stdcall
    option casemap :none
    
    include XXCtrl.inc
    include XXControls.inc

    include XXGrafics.asm  
    include XXMenu.asm
    include XXButton.asm

     
;--------------------------------------------------------------------------
.code

; #########################################################################
;                                                                         ;
;                                             ;  
;                                                                         ;
; #########################################################################

SetNewWndProc proc hWin :HWND, lpWndFunc:DWORD

    ;      
    ;          
    invoke GetWindowLong, hWin, GWL_WNDPROC
    cmp eax, lpWndFunc
    je e_t     
    
    invoke SetWindowLong, hWin, GWL_WNDPROC, lpWndFunc
    invoke SetProp, hWin, ADDR szProp_OldWndProc, eax

e_t:
    ret
SetNewWndProc endp

; #########################################################################

;                                                                         ;
;                                     ;  
;                                                                         ;
; #########################################################################

SetOldWndProc proc hWin :HWND, lpPrevWndFunc:DWORD

    ;      
    ;          
    invoke GetWindowLong, hWin, GWL_WNDPROC
    cmp eax, lpPrevWndFunc;offset WndProc_Menu
    jne e_t
    
    invoke GetProp, hWin, ADDR szProp_OldWndProc 
    invoke SetWindowLong, hWin, GWL_WNDPROC, eax
    invoke RemoveProp, hWin, ADDR szProp_OldWndProc

e_t:
    ret
SetOldWndProc endp

end